#include <d3d9.h>
#include <d3dx9.h>
#include "global.h"


class CDirect3D
{
   public:
 
        CDirect3D();
        virtual ~CDirect3D();

        // Direct3D initialisieren
        BOOL Init(HWND hWnd, BOOL bWindowed = TRUE);

        // Farbe fr den Backbuffer festlegen
        void SetClearColor(D3DCOLOR Color);

        // Text an Position x,y ausgeben
        void DrawText(LPCSTR Text, int x, int y, D3DCOLOR TextColor);

        // Methoden zum Start/Beenden der Szene 
        void BeginScene(void);
        void EndScene(void);

        void DrawEllipse(int x1, int y1, int x2, int y2, LPDIRECT3DSURFACE9 lpSurface);

        // Zeiger auf den Hintergrundbuffer zurckgeben
        LPDIRECT3DSURFACE9 GetBackbuffer(void);
 
        // Screenshot erstellen
        void CreateScreenshot(char* Filename);

        // das Direct3D-Device zurckgeben
        LPDIRECT3DDEVICE9 GetDevice(void);

   protected:
 
        // Erzeugen der D3D-Schrift
        void CreateFont(void);
        // Freigeben der Objekte
        void CleanUp(void);

        // Farbe fr den Backbuffer
        D3DCOLOR          m_ClearColor;

        // Direct3D Variablen
        LPDIRECT3D9       m_lpD3D;
        LPDIRECT3DDEVICE9 m_lpD3DDevice;
        LPD3DXFONT        m_lpD3DFont;

        LPDIRECT3DSURFACE9 m_lpBackBuffer;
};
