#include <d3d9.h>
#include <d3dx9.h>
#include <vector>

#include "global.h"

using namespace std;


// Definition der Bewegungsrichtungen
enum DIRECTION { LEFT, RIGHT, UP, DOWN };

// Definition der Spriteklasse
class CSprite
{
    public:
       CSprite();
       virtual ~CSprite();

       // Erzeugung des Sprites
       void Create(LPDIRECT3DDEVICE9 lpDevice,int AnimationSpeed, int Width, int Height);
        
       // Textur hinzufgen
       void AddTexture(LPCSTR lpFileName); 

       // Sprite zeichnen
       void Draw(void);
        
       // absolute Position festlegen
       void SetPosition(float x,float y);

       // absolute Rotation festlegen
       void SetRotation(float rotation);
        
       // absolute Skalierung festlegen
       void SetScale(float scale);
        
       // Schrittweite festlegen
       void SetStep(float StepX,float StepY);

       // relative Bewegung um StepX,StepY Pixel
       void Move(DIRECTION dir);
        
       // relative Skalierung 
       void Scale(float dScale);
        
       // relative Rotation
       void Rotate(float dRotation);

     protected:

       // Zeiger auf das Direct3D Device
       LPDIRECT3DDEVICE9 m_lpDevice;
        
       // Zeiger auf das ID3DXSprite-Objekt
       LPD3DXSPRITE m_lpSprite;
    
       // aktuelle Position
       D3DXVECTOR2 m_vPosition;
   
       // Skalierung
       D3DXVECTOR2 m_vScale;
    
       // Rotationsmittelpunkt
       D3DXVECTOR2 m_vRotationCenter;

       // aktuelle Rotation
       float m_Rotation;
   
       // Schrittweite
       float m_StepX;
       float m_StepY;

       // Breite und Hhe
       int   m_Width;
       int   m_Height;

	   // Breite und Hhe der Textur
	   int m_nTextureWidth;
	   int m_nTextureHeight;

	   // Geschwindigkeit fr die Animation
       int m_AnimationSpeed;

       // diese Variable wird erhhrt, bis m_AnimationSpeed
       // erreicht wurde und wird dann wieder auf 0 gesetzt
       // und die nchste Grafik wird angezeigt
       int m_AnimationDelay;

       // momentante Grafik (Textur) in der Animation
       int m_CurrentImageX;
	   int m_CurrentImageY;

       // vector zur Speicherung der Texturen fr die Animationen
       vector<LPDIRECT3DTEXTURE9> m_AnimationVec;
};
